package com.williamvanderhoef.foursquare.parsers;

import java.lang.reflect.Type;

import com.williamvanderhoef.foursquare.adapters.JsonSyntaxException;
import com.williamvanderhoef.foursquare.model.subtypes.Results;

/**
 * Copyright (c) 2011 William Vanderhoef
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 * @author William Vanderhoef william.vanderhoef@gmail.com
 *
 * @param <T>
 */
public interface ResultsParser<T> {

	/**
	 * 
	 * @param fileContents
	 * @return
	 * @throws JsonSyntaxException
	 */
	public Results<T> fromJson(String fileContents) throws JsonSyntaxException;
	
	/**
	 * 
	 * 
	 * @param object
	 * @return
	 * @throws JsonSyntaxException
	 */
	public String toJson(Object object) throws JsonSyntaxException;
	
	/**
	 * 
	 * @param json
	 * @param t
	 * @return
	 * @throws JsonSyntaxException
	 */
	public T simpleFromJson(String json, Type t)throws JsonSyntaxException;
	
}
